#include <iostream>
#include <istream>
using namespace std;

class Token
{
public:
    double value;
    char kind;

    Token(char op)    /// construct an operator Token
    {
        kind = op;
        value = 0;
    }
    Token(char op, double val) /// construct a number Token
        : kind(op), value(val)
    { }
};

Token get_Token()
{
    char input;
    cin >> input;
    if(int(input)>47 && int(input)<58)
    {
        cin.putback(input);
        double number;
        cin >> number;
        return Token('8',number);
    }
    switch(input)
    {
    case '+' :
        return Token('+');
    case '-' :
        return Token('-');
    case '*' :
        return Token('*');
    case '/' :
        return Token('/');
    case '%' :
        return Token('%');
    case '(' :
        return Token('(');
    case ')' :
        return Token(')');
    default :
        cout << "Bad Token";
        return Token('b');
    }
}

double expression();

double primary() {
    cout << "\ncalled primary";
    Token t = get_Token();
    switch(t.kind) {
    case '(': {
        double d = expression();
        t = get_Token();
        if(t.kind!=')') cout << "bad expression!";
        return d;
    }
    case '8':
        return t.value;
    default:
        cerr << "primary expected";
    }
}

double term() {
    cout << "\ncalled term";
    double left = primary();
    Token t = get_Token();
    //cout << "\nI'm here!";
    while(1) {
        switch(t.kind) {
        case '*':
            left *= primary();
            //cout << "\nleft = " << left;
            t = get_Token();
            break;
        case '/':
            left /= primary();
            t = get_Token();
            break;
//        case '%':
//            left %= primary();
//            t = get_Token();
//            break;
//        default:
            return left;
        }
    }
}

double expression()
{
    double left = term();
    cout << "\ncalled term.";
    Token t = get_Token();
    cout << "\nin expression";
    while(t.kind=='+' || t.kind == '-')
    {
        if(t.kind == '+')
            left += term();
        if(t.kind == '-')
            left -= term();
        t = get_Token();
    }
    return left;
}

int main()
{
    cout << "\nEnter an expression: ";
    while(1)
    {
        cout << expression();
    }
    return 0;
}
